# _Valtrace

```pony
actor tag _Valtrace
```

## Constructors

### create

```pony
new tag create()
: _Valtrace tag^
```

#### Returns

* [_Valtrace](builtin_test-_Valtrace) tag^

---

## Public fields

* var count: [U32](builtin-U32) val

---

## Public Behaviours

### one

Create a String iso, send it to a new actor.


```pony
be one(
  h: TestHelper val)
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

---

### two

Receive a String iso allocated by a different actor.
Append to it.
Send it as a val to a third actor.


```pony
be two(
  a1: _Valtrace tag,
  h: TestHelper val,
  s: String iso)
```
#### Parameters

*   a1: [_Valtrace](builtin_test-_Valtrace) tag
*   h: [TestHelper](ponytest-TestHelper) val
*   s: [String](builtin-String) iso

---

### three

Receive a String that was an iso that passed through another actor.


```pony
be three(
  a1: _Valtrace tag,
  a2: _Valtrace tag,
  h: TestHelper val,
  s: String val)
```
#### Parameters

*   a1: [_Valtrace](builtin_test-_Valtrace) tag
*   a2: [_Valtrace](builtin_test-_Valtrace) tag
*   h: [TestHelper](ponytest-TestHelper) val
*   s: [String](builtin-String) val

---

### four

Ask all actors to test the string.


```pony
be four(
  a1: _Valtrace tag,
  a2: _Valtrace tag,
  a3: _Valtrace tag,
  h: TestHelper val,
  s: String val)
```
#### Parameters

*   a1: [_Valtrace](builtin_test-_Valtrace) tag
*   a2: [_Valtrace](builtin_test-_Valtrace) tag
*   a3: [_Valtrace](builtin_test-_Valtrace) tag
*   h: [TestHelper](ponytest-TestHelper) val
*   s: [String](builtin-String) val

---

### gc

```pony
be gc(
  a: _Valtrace tag,
  h: TestHelper val,
  s: String val)
```
#### Parameters

*   a: [_Valtrace](builtin_test-_Valtrace) tag
*   h: [TestHelper](ponytest-TestHelper) val
*   s: [String](builtin-String) val

---

### done

```pony
be done(
  h: TestHelper val)
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

---

