# MapValues\[K: K, V: V, H: [HashFunction](collections-HashFunction)\[K\] val, M: [HashMap](collections-HashMap)\[K, V, H val\] #read\]

An iterator over the values in a map.


```pony
class ref MapValues[K: K, V: V, H: HashFunction[K] val, M: HashMap[K, V, H val] #read] is
  Iterator[M #read->V] ref
```

#### Implements

* [Iterator](builtin-Iterator)\[M #read->V\] ref

---

## Constructors

### create

```pony
new ref create(
  map: M #read)
: MapValues[K, V, H val, M #read] ref^
```
#### Parameters

*   map: M #read

#### Returns

* [MapValues](collections-MapValues)\[K, V, H val, M #read\] ref^

---

## Public Functions

### has_next

True if it believes there are remaining entries. May not be right if values
were added or removed from the map.


```pony
fun box has_next()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### next

Returns the next value, or raises an error if there isn't one. If values
are added during iteration, this may not return all values.


```pony
fun ref next()
: M #read->V ?
```

#### Returns

* M #read->V ?

---

