# SetValues\[A: A, H: [HashFunction](collections-HashFunction)\[A!\] val, S: [HashSet](collections-HashSet)\[A, H val\] #read\]

An iterator over the values in a set.


```pony
class ref SetValues[A: A, H: HashFunction[A!] val, S: HashSet[A, H val] #read] is
  Iterator[S #read->A] ref
```

#### Implements

* [Iterator](builtin-Iterator)\[S #read->A\] ref

---

## Constructors

### create

```pony
new ref create(
  set: S #read)
: SetValues[A, H val, S #read] ref^
```
#### Parameters

*   set: S #read

#### Returns

* [SetValues](collections-SetValues)\[A, H val, S #read\] ref^

---

## Public Functions

### has_next

True if it believes there are remaining entries. May not be right if values
were added or removed from the set.


```pony
fun box has_next()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### next

Returns the next value, or raises an error if there isn't one. If values
are added during iteration, this may not return all values.


```pony
fun ref next()
: S #read->A ?
```

#### Returns

* S #read->A ?

---

