# Sort\[A: [Seq](builtin-Seq)\[B #read\] ref, B: [Comparable](builtin-Comparable)\[B #read\] #read\]

Implementation of dual-pivot quicksort.


```pony
primitive val Sort[A: Seq[B #read] ref, B: Comparable[B #read] #read]
```

## Constructors

### create

```pony
new val create()
: Sort[A ref, B #read] val^
```

#### Returns

* [Sort](collections-Sort)\[A ref, B #read\] val^

---

## Public Functions

### apply

Sort the given seq.


```pony
fun box apply(
  a: A ref)
: A ref^
```
#### Parameters

*   a: A ref

#### Returns

* A ref^

---

### eq

```pony
fun box eq(
  that: Sort[A ref, B #read] val)
: Bool val
```
#### Parameters

*   that: [Sort](collections-Sort)\[A ref, B #read\] val

#### Returns

* [Bool](builtin-Bool) val

---

### ne

```pony
fun box ne(
  that: Sort[A ref, B #read] val)
: Bool val
```
#### Parameters

*   that: [Sort](collections-Sort)\[A ref, B #read\] val

#### Returns

* [Bool](builtin-Bool) val

---

## Private Functions

### _sort

```pony
fun box _sort(
  a: A ref,
  lo: ISize val,
  hi: ISize val)
: None val ?
```
#### Parameters

*   a: A ref
*   lo: [ISize](builtin-ISize) val
*   hi: [ISize](builtin-ISize) val

#### Returns

* [None](builtin-None) val ?

---

### _swap

```pony
fun box _swap(
  a: A ref,
  i: ISize val,
  j: ISize val)
: None val ?
```
#### Parameters

*   a: A ref
*   i: [ISize](builtin-ISize) val
*   j: [ISize](builtin-ISize) val

#### Returns

* [None](builtin-None) val ?

---

