# _MapNode\[K: [Any](builtin-Any) #share, V: [Any](builtin-Any) #share, H: [HashFunction](collections-HashFunction)\[K #share\] val\]

```pony
class val _MapNode[K: Any #share, V: Any #share, H: HashFunction[K #share] val]
```

## Constructors

### empty

```pony
new val empty(
  l: U8 val)
: _MapNode[K #share, V #share, H val] val^
```
#### Parameters

*   l: [U8](builtin-U8) val

#### Returns

* [_MapNode](collections-persistent-_MapNode)\[K #share, V #share, H val\] val^

---

### create

```pony
new val create(
  es: Array[(_MapNode[K #share, V #share, H val] val | Array[(K #share , V #share)] val | (K #share , V #share))] iso,
  nm: U32 val,
  dm: U32 val,
  l: U8 val)
: _MapNode[K #share, V #share, H val] val^
```
#### Parameters

*   es: [Array](builtin-Array)\[([_MapNode](collections-persistent-_MapNode)\[K #share, V #share, H val\] val | [Array](builtin-Array)\[(K #share , V #share)\] val | (K #share , V #share))\] iso
*   nm: [U32](builtin-U32) val
*   dm: [U32](builtin-U32) val
*   l: [U8](builtin-U8) val

#### Returns

* [_MapNode](collections-persistent-_MapNode)\[K #share, V #share, H val\] val^

---

## Public Functions

### apply

```pony
fun val apply(
  hash: U32 val,
  key: K #share)
: V #share ?
```
#### Parameters

*   hash: [U32](builtin-U32) val
*   key: K #share

#### Returns

* V #share ?

---

### update

```pony
fun val update(
  hash: U32 val,
  leaf: (K #share , V #share))
: (_MapNode[K #share, V #share, H val] val , Bool val) ?
```
#### Parameters

*   hash: [U32](builtin-U32) val
*   leaf: (K #share , V #share)

#### Returns

* ([_MapNode](collections-persistent-_MapNode)\[K #share, V #share, H val\] val , [Bool](builtin-Bool) val) ?

---

### remove

```pony
fun val remove(
  hash: U32 val,
  key: K #share)
: _MapNode[K #share, V #share, H val] val ?
```
#### Parameters

*   hash: [U32](builtin-U32) val
*   key: K #share

#### Returns

* [_MapNode](collections-persistent-_MapNode)\[K #share, V #share, H val\] val ?

---

### entries

```pony
fun box entries()
: Array[(_MapNode[K #share, V #share, H val] val | Array[(K #share , V #share)] val | (K #share , V #share))] val
```

#### Returns

* [Array](builtin-Array)\[([_MapNode](collections-persistent-_MapNode)\[K #share, V #share, H val\] val | [Array](builtin-Array)\[(K #share , V #share)\] val | (K #share , V #share))\] val

---

## Private Functions

### _compressed_index

```pony
fun box _compressed_index(
  nm: U32 val,
  dm: U32 val,
  idx: U32 val)
: U32 val
```
#### Parameters

*   nm: [U32](builtin-U32) val
*   dm: [U32](builtin-U32) val
*   idx: [U32](builtin-U32) val

#### Returns

* [U32](builtin-U32) val

---

