The crypto package includes a variety of common cryptographic algorithms
and functions often useful in cryptographic code for their use in information
security.


## Public Types

* [primitive ConstantTimeCompare](crypto-ConstantTimeCompare.md)
* [class Digest](crypto-Digest.md)
* [interface HashFn](crypto-HashFn.md)
* [primitive MD4](crypto-MD4.md)
* [primitive MD5](crypto-MD5.md)
* [primitive RIPEMD160](crypto-RIPEMD160.md)
* [primitive SHA1](crypto-SHA1.md)
* [primitive SHA224](crypto-SHA224.md)
* [primitive SHA256](crypto-SHA256.md)
* [primitive SHA384](crypto-SHA384.md)
* [primitive SHA512](crypto-SHA512.md)
* [primitive ToHexString](crypto-ToHexString.md)


## Private Types

* [primitive _EVPMD](crypto-_EVPMD.md)
* [primitive _EVPCTX](crypto-_EVPCTX.md)


## Test Types

* [actor Main](crypto-Main.md)
* [class _TestConstantTimeCompare](crypto-_TestConstantTimeCompare.md)
* [class _TestMD4](crypto-_TestMD4.md)
* [class _TestMD5](crypto-_TestMD5.md)
* [class _TestRIPEMD160](crypto-_TestRIPEMD160.md)
* [class _TestSHA1](crypto-_TestSHA1.md)
* [class _TestSHA224](crypto-_TestSHA224.md)
* [class _TestSHA256](crypto-_TestSHA256.md)
* [class _TestSHA384](crypto-_TestSHA384.md)
* [class _TestSHA512](crypto-_TestSHA512.md)
* [class _TestDigest](crypto-_TestDigest.md)
