# Chain\[A: A\]

Take an iterator of iterators and work through them, returning the
items of the first one, then the second one, and so on.

## Example program

Print the numbers 1 through 14

```pony
use "itertools"

actor Main
  new create(env: Env) =>
    let i1 = [as I32: 1, 2, 3, 4]
    let i2 = [as I32: 5, 6, 7, 8, 9]
    let i3 = [as I32: 10, 11, 12, 13, 14]
  
    for x in Chain[I32]([i1.values(), i2.values(), i3.values()].values()) do
      env.out.print(x.string())
    end
```


```pony
class ref Chain[A: A] is
  Iterator[A] ref
```

#### Implements

* [Iterator](builtin-Iterator)\[A\] ref

---

## Constructors

### create

```pony
new ref create(
  outer_iterator: Iterator[Iterator[A] ref] ref)
: Chain[A] ref^
```
#### Parameters

*   outer_iterator: [Iterator](builtin-Iterator)\[[Iterator](builtin-Iterator)\[A\] ref\] ref

#### Returns

* [Chain](itertools-Chain)\[A\] ref^

---

## Public Functions

### has_next

```pony
fun ref has_next()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### next

```pony
fun ref next()
: A ?
```

#### Returns

* A ?

---

