# Cycle\[A: A\]

Create an iterator that repeatedly cycles through the values from the
original iterator.

WARNING: The values returned by the original iterator are cached, so
the input iterator should be finite.

## Example program

Print the numbers 1 through 4 forever.

```pony
actor Main
  new create(env: Env) =>
    let i1 = [as I32: 1, 2, 3, 4]
    for x in Cycle[I32](i1.values()) do
      env.out.print(x.string())
    end
```


```pony
class ref Cycle[A: A] is
  Iterator[A] ref
```

#### Implements

* [Iterator](builtin-Iterator)\[A\] ref

---

## Constructors

### create

```pony
new ref create(
  iter: Iterator[A^] ref)
: Cycle[A] ref^
```
#### Parameters

*   iter: [Iterator](builtin-Iterator)\[A^\] ref

#### Returns

* [Cycle](itertools-Cycle)\[A\] ref^

---

## Public Functions

### has_next

```pony
fun ref has_next()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### next

```pony
fun ref next()
: A ?
```

#### Returns

* A ?

---

