# Repeat\[A: A\]

Create an iterator that returns the specified value forever.

## Example program

Print the number 7 forever.

```pony
use "itertools"

actor Main
  new create(env: Env) =>
    for x in Repeat[U32](7) do
      env.out.print(x.string())
    end
```


```pony
class ref Repeat[A: A] is
  Iterator[A] ref
```

#### Implements

* [Iterator](builtin-Iterator)\[A\] ref

---

## Constructors

### create

```pony
new ref create(
  v: A)
: Repeat[A] ref^
```
#### Parameters

*   v: A

#### Returns

* [Repeat](itertools-Repeat)\[A\] ref^

---

## Public Functions

### has_next

```pony
fun ref has_next()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### next

```pony
fun ref next()
: A
```

#### Returns

* A

---

