# Take\[A: A\]

Create an iterator from the original iterator that only returns a
specified number of items.

## Example program

Prints the numbers 10 through 12.

```pony
use "itertools"

actor Main
  new create(env: Env) =>
    let i1 = [as I32: 10, 11, 12, 13, 14]
  
    for x in Take[I32](i1.values(), 3) do
      env.out.print(x.string())
    end
```


```pony
class ref Take[A: A] is
  Iterator[A] ref
```

#### Implements

* [Iterator](builtin-Iterator)\[A\] ref

---

## Constructors

### create

```pony
new ref create(
  i: Iterator[A] ref,
  l: USize val)
: Take[A] ref^
```
#### Parameters

*   i: [Iterator](builtin-Iterator)\[A\] ref
*   l: [USize](builtin-USize) val

#### Returns

* [Take](itertools-Take)\[A\] ref^

---

## Public Functions

### has_next

```pony
fun ref has_next()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### next

```pony
fun ref next()
: A ?
```

#### Returns

* A ?

---

