# _TestObjectLogging

```pony
class ref _TestObjectLogging is
  _LoggerTest[U64 val] ref
```

#### Implements

* [_LoggerTest](logger-_LoggerTest)\[[U64](builtin-U64) val\] ref

---

## Constructors

### create

```pony
new iso create()
: _TestObjectLogging iso^
```

#### Returns

* [_TestObjectLogging](logger-_TestObjectLogging) iso^

---

## Public Functions

### name

```pony
fun box name()
: String val
```

#### Returns

* [String](builtin-String) val

---

### logger

```pony
fun box logger(
  level': (Fine val | Info val | Warn val | 
    Error val),
  stream': OutStream tag,
  formatter': LogFormatter val)
: Logger[U64 val] val
```
#### Parameters

*   level': ([Fine](logger-Fine) val | [Info](logger-Info) val | [Warn](logger-Warn) val | 
    [Error](logger-Error) val)
*   stream': [OutStream](builtin-OutStream) tag
*   formatter': [LogFormatter](logger-LogFormatter) val

#### Returns

* [Logger](logger-Logger)\[[U64](builtin-U64) val\] val

---

### level

```pony
fun box level()
: (Fine val | Info val | Warn val | 
    Error val)
```

#### Returns

* ([Fine](logger-Fine) val | [Info](logger-Info) val | [Warn](logger-Warn) val | 
    [Error](logger-Error) val)

---

### expected

```pony
fun tag expected()
: String val
```

#### Returns

* [String](builtin-String) val

---

### log

```pony
fun box log(
  logger': Logger[U64 val] val)
: None val
```
#### Parameters

*   logger': [Logger](logger-Logger)\[[U64](builtin-U64) val\] val

#### Returns

* [None](builtin-None) val

---

### apply

```pony
fun box apply(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### timed_out

```pony
fun box timed_out(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### exclusion_group

```pony
fun box exclusion_group()
: String val
```

#### Returns

* [String](builtin-String) val

---

### tear_down

```pony
fun ref tear_down(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### label

```pony
fun box label()
: String val
```

#### Returns

* [String](builtin-String) val

---

## Private Functions

### _fulfill

```pony
fun tag _fulfill(
  h: TestHelper val,
  value: String val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val
*   value: [String](builtin-String) val

#### Returns

* [None](builtin-None) val

---

