# Net package

The Net package provides support for creating UDP and TCP clients and
servers, reading and writing network data, and establishing UDP and
TCP connections.


## Public Types

* [primitive NetAuth](net-NetAuth.md)
* [primitive DNSAuth](net-DNSAuth.md)
* [primitive UDPAuth](net-UDPAuth.md)
* [primitive TCPAuth](net-TCPAuth.md)
* [primitive TCPListenAuth](net-TCPListenAuth.md)
* [primitive TCPConnectAuth](net-TCPConnectAuth.md)
* [type DNSLookupAuth](net-DNSLookupAuth.md)
* [primitive DNS](net-DNS.md)
* [class NetAddress](net-NetAddress.md)
* [type TCPConnectionAuth](net-TCPConnectionAuth.md)
* [actor TCPConnection](net-TCPConnection.md)
* [interface TCPConnectionNotify](net-TCPConnectionNotify.md)
* [interface TCPListenNotify](net-TCPListenNotify.md)
* [type TCPListenerAuth](net-TCPListenerAuth.md)
* [actor TCPListener](net-TCPListener.md)
* [interface UDPNotify](net-UDPNotify.md)
* [type UDPSocketAuth](net-UDPSocketAuth.md)
* [actor UDPSocket](net-UDPSocket.md)


## Test Types

* [actor Main](net-Main.md)
* [class _TestPing](net-_TestPing.md)
* [class _TestPong](net-_TestPong.md)
* [class _TestBroadcast](net-_TestBroadcast.md)
* [class _TestTCP](net-_TestTCP.md)
* [class _TestTCPExpect](net-_TestTCPExpect.md)
* [class _TestTCPExpectNotify](net-_TestTCPExpectNotify.md)
* [class _TestTCPWritev](net-_TestTCPWritev.md)
* [class _TestTCPWritevNotifyClient](net-_TestTCPWritevNotifyClient.md)
* [class _TestTCPWritevNotifyServer](net-_TestTCPWritevNotifyServer.md)
* [class _TestTCPMute](net-_TestTCPMute.md)
* [class _TestTCPMuteReceiveNotify](net-_TestTCPMuteReceiveNotify.md)
* [class _TestTCPMuteSendNotify](net-_TestTCPMuteSendNotify.md)
* [class _TestTCPUnmute](net-_TestTCPUnmute.md)
* [class _TestTCPUnmuteReceiveNotify](net-_TestTCPUnmuteReceiveNotify.md)
* [class _TestTCPThrottle](net-_TestTCPThrottle.md)
* [class _TestTCPThrottleReceiveNotify](net-_TestTCPThrottleReceiveNotify.md)
* [class _TestTCPThrottleSendNotify](net-_TestTCPThrottleSendNotify.md)
