# _TestTCP

Run a typical TCP test consisting of a single TCPListener that accepts a
single TCPConnection as a client, using a dynamic available listen port.


```pony
class ref _TestTCP is
  TCPListenNotify ref
```

#### Implements

* [TCPListenNotify](net-TCPListenNotify) ref

---

## Constructors

### create

```pony
new iso create(
  h: TestHelper val)
: _TestTCP iso^
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [_TestTCP](net-_TestTCP) iso^

---

## Public Functions

### apply

```pony
fun iso apply(
  c: TCPConnectionNotify iso,
  s: TCPConnectionNotify iso)
: None val
```
#### Parameters

*   c: [TCPConnectionNotify](net-TCPConnectionNotify) iso
*   s: [TCPConnectionNotify](net-TCPConnectionNotify) iso

#### Returns

* [None](builtin-None) val

---

### not_listening

```pony
fun ref not_listening(
  listen: TCPListener ref)
: None val
```
#### Parameters

*   listen: [TCPListener](net-TCPListener) ref

#### Returns

* [None](builtin-None) val

---

### listening

```pony
fun ref listening(
  listen: TCPListener ref)
: None val
```
#### Parameters

*   listen: [TCPListener](net-TCPListener) ref

#### Returns

* [None](builtin-None) val

---

### connected

```pony
fun ref connected(
  listen: TCPListener ref)
: TCPConnectionNotify iso^ ?
```
#### Parameters

*   listen: [TCPListener](net-TCPListener) ref

#### Returns

* [TCPConnectionNotify](net-TCPConnectionNotify) iso^ ?

---

### closed

```pony
fun ref closed(
  listen: TCPListener ref)
: None val
```
#### Parameters

*   listen: [TCPListener](net-TCPListener) ref

#### Returns

* [None](builtin-None) val

---

