# _TestTCPMute

Test that the `mute` behavior stops us from reading incoming data. The
test assumes that send/recv works correctly and that the absence of
data received is because we muted the connection.

Test works as follows:

Once an incoming connection is established, we set mute on it and then
verify that within a 2 second long test that received is not called on
our notifier. A timeout is considering passing and received being called
is grounds for a failure.


```pony
class iso _TestTCPMute is
  UnitTest ref
```

#### Implements

* [UnitTest](ponytest-UnitTest) ref

---

## Constructors

### create

```pony
new iso create()
: _TestTCPMute iso^
```

#### Returns

* [_TestTCPMute](net-_TestTCPMute) iso^

---

## Public Functions

### name

```pony
fun box name()
: String val
```

#### Returns

* [String](builtin-String) val

---

### exclusion_group

```pony
fun box exclusion_group()
: String val
```

#### Returns

* [String](builtin-String) val

---

### apply

```pony
fun ref apply(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### timed_out

```pony
fun box timed_out(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### tear_down

```pony
fun ref tear_down(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### label

```pony
fun box label()
: String val
```

#### Returns

* [String](builtin-String) val

---

