# _TestTCPThrottle

Test that when we experience backpressure when sending that the `throttled`
method is called on our `TCPConnectionNotify` instance.

We do this by starting up a server connection, muting it immediately and then
sending data to it which should trigger a throttling to happen. We don't
start sending data til after the receiver has muted itself and sent the
sender data. This verifies that muting has been completed before any data is
sent as part of testing throttling.

This test assumes that muting functionality is working correctly.


```pony
class iso _TestTCPThrottle is
  UnitTest ref
```

#### Implements

* [UnitTest](ponytest-UnitTest) ref

---

## Constructors

### create

```pony
new iso create()
: _TestTCPThrottle iso^
```

#### Returns

* [_TestTCPThrottle](net-_TestTCPThrottle) iso^

---

## Public Functions

### name

```pony
fun box name()
: String val
```

#### Returns

* [String](builtin-String) val

---

### exclusion_group

```pony
fun box exclusion_group()
: String val
```

#### Returns

* [String](builtin-String) val

---

### apply

```pony
fun ref apply(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### timed_out

```pony
fun ref timed_out(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### tear_down

```pony
fun ref tear_down(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### label

```pony
fun box label()
: String val
```

#### Returns

* [String](builtin-String) val

---

