# _TestTCPUnmute

Test that the `unmute` behavior will allow a connection to start reading
incoming data again. The test assumes that `mute` works correctly and that
after muting, `unmute` successfully reset the mute state rather than `mute`
being broken and never actually muting the connection.

Test works as follows:

Once an incoming connection is established, we set mute on it, request
that data be sent to us and then unmute the connection such that we should
receive the return data.


```pony
class iso _TestTCPUnmute is
  UnitTest ref
```

#### Implements

* [UnitTest](ponytest-UnitTest) ref

---

## Constructors

### create

```pony
new iso create()
: _TestTCPUnmute iso^
```

#### Returns

* [_TestTCPUnmute](net-_TestTCPUnmute) iso^

---

## Public Functions

### name

```pony
fun box name()
: String val
```

#### Returns

* [String](builtin-String) val

---

### exclusion_group

```pony
fun box exclusion_group()
: String val
```

#### Returns

* [String](builtin-String) val

---

### apply

```pony
fun ref apply(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### timed_out

```pony
fun ref timed_out(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### tear_down

```pony
fun ref tear_down(
  h: TestHelper val)
: None val
```
#### Parameters

*   h: [TestHelper](ponytest-TestHelper) val

#### Returns

* [None](builtin-None) val

---

### label

```pony
fun box label()
: String val
```

#### Returns

* [String](builtin-String) val

---

