# _TestRecord

Store and report the result and log from a single test.


```pony
class ref _TestRecord
```

## Constructors

### create

```pony
new ref create(
  env: Env val,
  name': String val)
: _TestRecord ref^
```
#### Parameters

*   env: [Env](builtin-Env) val
*   name': [String](builtin-String) val

#### Returns

* [_TestRecord](ponytest-_TestRecord) ref^

---

## Public fields

* let name: [String](builtin-String) val

---

## Private Functions

### _result

Our test has completed, store the result.


```pony
fun ref _result(
  pass: Bool val,
  log: Array[String val] val)
: None val
```
#### Parameters

*   pass: [Bool](builtin-Bool) val
*   log: [Array](builtin-Array)\[[String](builtin-String) val\] val

#### Returns

* [None](builtin-None) val

---

### _report

Print our test summary, including the log if appropriate.
The log_all parameter indicates whether we've been told to print logs for
all tests. The default is to only print logs for tests that fail.
Returns our pass / fail status.


```pony
fun box _report(
  log_all: Bool val)
: Bool val
```
#### Parameters

*   log_all: [Bool](builtin-Bool) val

#### Returns

* [Bool](builtin-Bool) val

---

### _list_failed

Print our test name out in the list of failed test, if we failed.


```pony
fun box _list_failed()
: None val
```

#### Returns

* [None](builtin-None) val

---

