# _Then\[A: [Any](builtin-Any) #share, B: [Any](builtin-Any) #share\]

A step in a promise pipeline.


```pony
class ref _Then[A: Any #share, B: Any #share]
```

## Constructors

### create

```pony
new iso create(
  fulfill: Fulfill[A #share, B #share] iso,
  rejected: Reject[B #share] iso)
: _Then[A #share, B #share] iso^
```
#### Parameters

*   fulfill: [Fulfill](promises-Fulfill)\[A #share, B #share\] iso
*   rejected: [Reject](promises-Reject)\[B #share\] iso

#### Returns

* [_Then](promises-_Then)\[A #share, B #share\] iso^

---

## Public Functions

### promise

Returns the next promise in the chain.


```pony
fun box promise()
: Promise[B #share] tag
```

#### Returns

* [Promise](promises-Promise)\[B #share\] tag

---

### apply

Called with the result of the previous promise when it is fulfilled.


```pony
fun ref apply(
  value: A #share)
: None val
```
#### Parameters

*   value: A #share

#### Returns

* [None](builtin-None) val

---

### reject

Called when the previous promise is rejected.


```pony
fun ref reject()
: None val
```

#### Returns

* [None](builtin-None) val

---

